package net.sergecoude.util;

import java.awt.*;
import java.awt.image.*;
import javax.swing.*;

public class JButtonTranslucide extends JButton {

  private final static long serialVersionUID = 1L;

  private BufferedImage image = null ;
  private float _opacite = 0.2f;
   
  public JButtonTranslucide(float opacite) {
    _opacite = opacite;
  }

  @Override
  public void paint ( Graphics g ) {
    if ( image == null || image.getWidth () != getWidth () || image.getHeight () != getHeight ()) {
      image = ( BufferedImage ) createImage ( getWidth () , getHeight ()) ;
    }

    Graphics2D g2 = image.createGraphics () ;
/*    g2.setClip ( g.getClip ()) ;
    super .paint ( g2 ) ;
    g2.dispose () ;
*/
    g2 = ( Graphics2D ) g. create () ;
    g2.setComposite ( AlphaComposite.SrcOver.derive ( _opacite )) ;

    g2.drawImage ( image, 0 , 0 , null ) ;

    if (getBackground() != null) {
      g2.setColor(getBackground());
      g2.fillRect(0,0,getWidth(),getHeight());
    }

    g2.setComposite ( AlphaComposite.SrcIn) ;
    
    g2.setClip ( g.getClip ()) ;
    super .paint ( g2 ) ;
    g2.dispose () ;

  }
  
}